//**************************************
// TP3 (CAPAX-MD) : Commande PID
// V1.0 Le 14/08/2018
// CAPAX SYSTEMS by www.infoconsult.tn
//**************************************

# define MCC_pin 9 // Commande de la vitesse du "MCC" 
# define HALL_pin 2 // Lecture des implusion du capteur à effet HALL_pin.

unsigned long time; // Déclaration de la variable "time".
unsigned long AncienTemps = 0; // Déclaration de la variable "AncienTemps".
unsigned long Duree = 0; // Déclaration de la variable "Dureeee" de long.
unsigned long TempsCalcul; // Déclaration de la variable "TempsCalcul"
unsigned long AncienTempsCalcul; // Déclaration de la variable "AncienTempsCalcul"

float delta_erreur = 0; // Erreur dérivée
float somme_erreur = 0; // somme erreur intégrale
float kp = 0.085046; // le Coefficient proportionnel
float ki = 0.040761; // le Coefficient intégral.
float kd = 0.0 ; // le Coefficient dérivateur.
int Te = 15000; // la période d'échantillonnage [microsseconds]
float consigne = 1500.0; // consigne [tr/mn]
int k;
float err_p; // erreur précédente qui entre dans le calcul de l'action dérivée
float err;
float cmd_vit; // commande analogique
int cmd; // commande numérique, <=0 cmd <= 255
unsigned long vit_mes;


// pid  = Kp*err + Ki*integrale*dt + Kd*derivee/dt

void setup() {
  Serial.begin (250000);
  pinMode(MCC_pin, OUTPUT); 
  pinMode(HALL_pin, INPUT);
  attachInterrupt(digitalPinToInterrupt(HALL_pin), TimeCount, FALLING);
}

void loop(){
  AncienTempsCalcul = micros();
  if (Duree == 0){ // Pour éviter la division par zéro de la vitesse
    vit_mes = 0; // La variable "vit_mes" prend 0
  }
  else {
    vit_mes = float(60000000 / Duree); // Conversion de la vitesse mesurée en tr/mn
  }
  err = consigne - vit_mes;
  somme_erreur = somme_erreur + err * Te / 1000000; // conversion de Te en unité SI
  //delta_err = (err-err_p)/Te;
  cmd_vit = kp * err + ki * somme_erreur; // + kd*delta_err/Te;
  if (cmd_vit >= 5.0) {
    cmd = 255;
  }
  else if (cmd_vit <= 0) {
    cmd = 0;
  }
  else {
    cmd = int(cmd_vit * 51.0); // 51 = 255/5
    //cmd = int(cmd_vit*53.6842); //53.6842=255/4.75
  }

  analogWrite(MCC_pin, cmd);
 
  for (k = 0; k <= 8; k += 8) {
    int j = vit_mes >> k; // Ecriture sur le port série de la variable 'Vit' : la réponse
    Serial.write(j);
  }
  for (int k = 0; k <= 8; k += 8){
    int j = cmd >> k; // Ecriture sur le port série de la variable 'cmd' : la commande
    Serial.write(j);
  }
//    Serial.write('\r');
  TempsCalcul = micros() - AncienTempsCalcul;
  delayMicroseconds(Te - TempsCalcul);
}

void TimeCount(){
  time = micros();
  Duree = time - AncienTemps;
  AncienTemps = time;
}
